﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.Core;
using Core.Presentation;
using ThinkGeo.MapSuite.WpfDesktopEdition;
using System.IO;

namespace Distance
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void wpfMap1_MouseMove(object sender, MouseEventArgs e)
        {
            try
            {
                Point xxxx = e.GetPosition(wpfMap1);

                PointShape pointShape = ExtentHelper.ToWorldCoordinate(wpfMap1.CurrentExtent, new ScreenPointF((float)xxxx.X, (float)xxxx.Y), (float)wpfMap1.Width, (float)wpfMap1.Height);
            }
            catch { }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {

            wpfMap1.AdornmentOverlay.ShowLogo = false;

            wpfMap1.MapUnit = GeographyUnit.Meter;

            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();
            dlg.FileName = ""; // Default file name
            dlg.DefaultExt = ".shp"; // Default file extension
            dlg.Filter =
                "Shape Files (*.shp)|*.shp";

            Nullable<bool> result = dlg.ShowDialog();
            if (result == true)
            {

                string FileExtension = (new FileInfo(dlg.SafeFileName)).Extension.ToLower();
                string FileNameWithouExtension = System.IO.Path.GetFileNameWithoutExtension(dlg.FileName);

                LayerOverlay layerOverlay = new LayerOverlay();
                layerOverlay.TransitionEffect = TransitionEffect.None;
                ShapeFileFeatureLayer shpLayer = new ShapeFileFeatureLayer(dlg.FileName);

                shpLayer.Open();
                wpfMap1.CurrentExtent = shpLayer.GetBoundingBox();
                switch (shpLayer.GetShapeFileType())
                {
                    case ShapeFileType.Polygon:
                        shpLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.County1;
                        break;

                    case ShapeFileType.Polyline:
                        shpLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Black, 1, true);
                        break;

                    case ShapeFileType.Point:
                        shpLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.SimpleColors.DarkBlue, (float)5.0);
                        break;
                }
                shpLayer.Close();
                shpLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                layerOverlay.Layers.Add(FileNameWithouExtension, shpLayer);
                wpfMap1.Overlays.Add(FileNameWithouExtension, layerOverlay);

                //RulerTrackInteractiveOverlay rulerTrackInteractiveOverlay = new RulerTrackInteractiveOverlay();
                MeasureTrackInteractiveOverlay rulerTrackInteractiveOverlay = new MeasureTrackInteractiveOverlay();
                rulerTrackInteractiveOverlay.TrackEnded += (o, a) => { rulerTrackInteractiveOverlay.TrackShapeLayer.InternalFeatures.Clear(); };
                wpfMap1.TrackOverlay = rulerTrackInteractiveOverlay;
                wpfMap1.TrackOverlay.TrackMode = TrackMode.StraightLine;

                wpfMap1.Refresh();

            }
        }
    }
}

